<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.application.d4py &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.application.d4py</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.application.d4py</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">Declare4Py.ProcessModels.DeclareModel</span> <span class="kn">import</span> <span class="n">DeclareModel</span>
<span class="kn">from</span> <span class="nn">Declare4Py.ProcessMiningTasks.Discovery.DeclareMiner</span> <span class="kn">import</span> <span class="n">DeclareMiner</span>
<span class="kn">from</span> <span class="nn">Declare4Py.D4PyEventLog</span> <span class="kn">import</span> <span class="n">D4PyEventLog</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.declare_constraint</span> <span class="kn">import</span> <span class="n">DeclareConstraint</span>
<span class="kn">from</span> <span class="nn">nl2declare.constructs.constraint_type</span> <span class="kn">import</span> <span class="n">ConstraintType</span>
<span class="kn">from</span> <span class="nn">Declare4Py.ProcessMiningTasks.ConformanceChecking.MPDeclareAnalyzer</span> <span class="kn">import</span> <span class="n">MPDeclareAnalyzer</span>
<span class="kn">from</span> <span class="nn">Declare4Py.ProcessMiningTasks.ConformanceChecking.MPDeclareResultsBrowser</span> <span class="kn">import</span> <span class="n">MPDeclareResultsBrowser</span>


<div class="viewcode-block" id="create_d4py_declaremodel"><a class="viewcode-back" href="../../../nl2declare.application.html#nl2declare.application.d4py.create_d4py_declaremodel">[docs]</a><span class="k">def</span> <span class="nf">create_d4py_declaremodel</span> <span class="p">(</span><span class="n">constraints</span><span class="p">:</span> <span class="nb">set</span><span class="p">[</span><span class="n">DeclareConstraint</span><span class="p">]):</span>
    <span class="n">result</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">activities</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">const</span> <span class="ow">in</span> <span class="n">constraints</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">activities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">())</span>
        <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">activities</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">())</span>
    
    <span class="c1">#remove duplicates</span>
    <span class="n">activities</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">set</span><span class="p">(</span><span class="n">activities</span><span class="p">))</span>

    <span class="k">for</span> <span class="n">act</span> <span class="ow">in</span> <span class="n">activities</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;activity &quot;</span> <span class="o">+</span> <span class="n">act</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
    
    <span class="k">for</span> <span class="n">const</span> <span class="ow">in</span> <span class="n">constraints</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">INIT</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Init[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
        <span class="k">elif</span> <span class="n">const</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">END</span><span class="p">:</span>
            <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;End[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
        <span class="k">elif</span> <span class="n">const</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">RESPONSE</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Not Response[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Response[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>    
        <span class="k">elif</span> <span class="n">const</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">PRECEDENCE</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Not Precedence[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Precedence[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
        <span class="k">elif</span> <span class="n">const</span><span class="o">.</span><span class="n">type</span> <span class="o">==</span> <span class="n">ConstraintType</span><span class="o">.</span><span class="n">SUCCESSION</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">const</span><span class="o">.</span><span class="n">is_negative</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Not Succession[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">result</span> <span class="o">=</span> <span class="n">result</span> <span class="o">+</span> <span class="s2">&quot;Succession[&quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_a</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;, &quot;</span> <span class="o">+</span> <span class="n">const</span><span class="o">.</span><span class="n">action_b</span><span class="o">.</span><span class="n">action_str</span><span class="p">()</span> <span class="o">+</span> <span class="s2">&quot;] | | | &quot;</span> <span class="o">+</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span>
    
    <span class="k">return</span> <span class="n">result</span></div>

<div class="viewcode-block" id="compute_precision"><a class="viewcode-back" href="../../../nl2declare.application.html#nl2declare.application.d4py.compute_precision">[docs]</a><span class="k">def</span> <span class="nf">compute_precision</span><span class="p">(</span><span class="n">model_constraints</span><span class="p">:</span> <span class="p">[</span><span class="nb">str</span><span class="p">],</span> <span class="n">log_constraints</span><span class="p">:</span> <span class="p">[</span><span class="nb">str</span><span class="p">]):</span>
    <span class="n">matches</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">model_const</span> <span class="ow">in</span> <span class="n">model_constraints</span><span class="p">:</span>
        <span class="c1">#remove | from the constraints</span>
        <span class="n">split_parts</span> <span class="o">=</span> <span class="n">model_const</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;]&#39;</span><span class="p">)</span>
        <span class="n">model_const_new</span> <span class="o">=</span> <span class="n">split_parts</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39;]&#39;</span>
        <span class="k">for</span> <span class="n">log_const</span> <span class="ow">in</span> <span class="n">log_constraints</span><span class="p">:</span>
            <span class="c1">#remove | from the constraints</span>
            <span class="n">split_parts</span> <span class="o">=</span> <span class="n">log_const</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;]&#39;</span><span class="p">)</span>
            <span class="n">log_const_new</span> <span class="o">=</span> <span class="n">split_parts</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39;]&#39;</span>
            <span class="k">if</span> <span class="n">model_const_new</span> <span class="o">==</span> <span class="n">log_const_new</span><span class="p">:</span>
                <span class="n">matches</span> <span class="o">+=</span><span class="mi">1</span>
                <span class="k">break</span>
    
    <span class="k">return</span> <span class="n">matches</span><span class="o">/</span><span class="nb">len</span><span class="p">(</span><span class="n">model_constraints</span><span class="p">)</span></div>

<div class="viewcode-block" id="get_conformance_metrics"><a class="viewcode-back" href="../../../nl2declare.application.html#nl2declare.application.d4py.get_conformance_metrics">[docs]</a><span class="k">def</span> <span class="nf">get_conformance_metrics</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">event_log</span><span class="p">):</span>
    <span class="n">basic_checker</span> <span class="o">=</span> <span class="n">MPDeclareAnalyzer</span><span class="p">(</span><span class="n">log</span><span class="o">=</span><span class="n">event_log</span><span class="p">,</span> <span class="n">declare_model</span><span class="o">=</span><span class="n">model</span><span class="p">,</span> <span class="n">consider_vacuity</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">conf_check_res</span><span class="p">:</span> <span class="n">MPDeclareResultsBrowser</span> <span class="o">=</span> <span class="n">basic_checker</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>

    <span class="n">result_csv</span> <span class="o">=</span> <span class="n">create_result_csv_content</span><span class="p">(</span><span class="n">conf_check_res</span><span class="p">)</span>
    
    <span class="k">return</span> <span class="n">result_csv</span></div>

<div class="viewcode-block" id="create_result_csv_content"><a class="viewcode-back" href="../../../nl2declare.application.html#nl2declare.application.d4py.create_result_csv_content">[docs]</a><span class="k">def</span> <span class="nf">create_result_csv_content</span><span class="p">(</span><span class="n">conf_check_res</span><span class="p">):</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="c1">#no. activations</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;number of activations </span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;trace id&quot;</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">conf_check_res</span><span class="o">.</span><span class="n">get_metric</span><span class="p">(</span><span class="s2">&quot;num_activations&quot;</span><span class="p">)</span>
    <span class="n">sub_result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">sep</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">)</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="n">sub_result</span>

    <span class="c1">#no. fulfillments</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;number of fulfillments </span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;trace id&quot;</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">conf_check_res</span><span class="o">.</span><span class="n">get_metric</span><span class="p">(</span><span class="s2">&quot;num_fulfillments&quot;</span><span class="p">)</span>
    <span class="n">sub_result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">sep</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">)</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="n">sub_result</span>

    <span class="c1">#no. violations</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;number of violations </span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;trace id&quot;</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">conf_check_res</span><span class="o">.</span><span class="n">get_metric</span><span class="p">(</span><span class="s2">&quot;num_violations&quot;</span><span class="p">)</span>
    <span class="n">sub_result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">sep</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">)</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="n">sub_result</span>

    <span class="c1">#state</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;state </span><span class="se">\n</span><span class="s2">&quot;</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="s2">&quot;trace id&quot;</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">conf_check_res</span><span class="o">.</span><span class="n">get_metric</span><span class="p">(</span><span class="s2">&quot;state&quot;</span><span class="p">)</span>
    <span class="n">sub_result</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">to_csv</span><span class="p">(</span><span class="n">sep</span><span class="o">=</span><span class="s1">&#39;;&#39;</span><span class="p">)</span>
    <span class="n">csv_result</span> <span class="o">=</span> <span class="n">csv_result</span> <span class="o">+</span> <span class="n">sub_result</span>

    <span class="k">return</span> <span class="n">csv_result</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>